
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MessagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.create(
            {
                id: data.id || undefined,
        
        sender_type: data.sender_type
        ||
        null
            ,
            
        message_body: data.message_body
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        is_read: data.is_read
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await messages.setChat_session( data.chat_session || null, {
            transaction,
        });
        
        await messages.setSender_user( data.sender_user || null, {
            transaction,
        });
        
        await messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: messages.id,
            },
            data.attachments,
            options,
        );
        

        return messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sender_type: item.sender_type
            ||
            null
            ,
            
                message_body: item.message_body
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                is_read: item.is_read
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const messages = await db.messages.bulkCreate(messagesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < messages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.messages.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: messages[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const messages = await db.messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sender_type !== undefined) updatePayload.sender_type = data.sender_type;
        
        
        if (data.message_body !== undefined) updatePayload.message_body = data.message_body;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.is_read !== undefined) updatePayload.is_read = data.is_read;
        
        
        updatePayload.updatedById = currentUser.id;

        await messages.update(updatePayload, {transaction});

        
        
        if (data.chat_session !== undefined) {
            await messages.setChat_session(
              
              data.chat_session,
              
              { transaction }
            );
        }
        
        if (data.sender_user !== undefined) {
            await messages.setSender_user(
              
              data.sender_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: messages.id,
            },
            data.attachments,
            options,
        );
        

        return messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of messages) {
                await record.destroy({transaction});
            }
        });


        return messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findByPk(id, options);

        await messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await messages.destroy({
            transaction
        });

        return messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findOne(
            { where },
            { transaction },
        );

        if (!messages) {
            return messages;
        }

        const output = messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.chat_session = await messages.getChat_session({
            transaction
        });
        
        
        output.sender_user = await messages.getSender_user({
            transaction
        });
        
        
        output.attachments = await messages.getAttachments({
            transaction
        });
        
        
        output.organizations = await messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.chat_sessions,
        as: 'chat_session',
        
        where: filter.chat_session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.chat_session.split('|').map(term => Utils.uuid(term)) } },
            {
              session_status: {
                [Op.or]: filter.chat_session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'sender_user',
        
        where: filter.sender_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sender_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.sender_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message_body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'messages',
                        'message_body',
                        filter.message_body,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.sender_type) {
                where = {
                    ...where,
                sender_type: filter.sender_type,
            };
            }
            
            if (filter.is_read) {
                where = {
                    ...where,
                is_read: filter.is_read,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'messages',
                        'message_body',
                        query,
                    ),
                ],
            };
        }

        const records = await db.messages.findAll({
            attributes: [ 'id', 'message_body' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message_body', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message_body,
        }));
    }

    
};

